"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Client = void 0;
const axios_1 = __importDefault(require("axios"));
const ws_1 = require("ws");
const client = new ws_1.WebSocket("wss://socket.trakteer.id/app/2ae25d102cc6cd41100a?protocol=7&client=js&version=5.1.1&flash=false");
setInterval(() => {
    client.send(JSON.stringify({
        data: {},
        event: "pusher:ping"
    }));
}, 5000);
class Client extends ws_1.EventEmitter {
    username;
    streamKey;
    userId;
    /**
     * Client Class
     * @param pageID should be the trakteer page id (NOT Username). check pageID in https://trakteer.id/manage/my-page/settings
     * @param streamKey should be `trstream-xxx`. check key in https://trakteer.id/manage/stream-settings
     */
    constructor(pageID, streamKey) {
        super();
        this.username = pageID;
        this.streamKey = streamKey;
        client.on("open", () => {
            this.emit("connect");
        });
        client.on("message", (message) => {
            if (message.toString().startsWith(`{"channel"`)) {
                this.emit("donation", JSON.parse(JSON.parse(message.toString()).data));
            }
        });
    }
    /**
     * please use this before using any code. to initialize the client
     */
    async start() {
        const data = (await axios_1.default.get(`https://trakteer.id/${this.username}/stream?key=${this.streamKey}`));
        const userid = data.data;
        const result = (/creator-stream\.(.*?)\./gi.exec(userid));
        this.userId = result[1];
        //Subscribe ke Streaming agar mendapatkan feedback
        client.send(JSON.stringify({
            event: "pusher:subscribe",
            data: {
                auth: "",
                channel: `creator-stream.${this.userId}.${this.streamKey}`
            }
        }));
        //Subscribe ke Streaming test agar mendapatkan feedback
        client.send(JSON.stringify({
            event: "pusher:subscribe",
            data: {
                auth: "",
                channel: `creator-stream-test.${this.userId}.${this.streamKey}`
            }
        }));
    }
    on2(event, cb) {
        switch (event) {
            case "donation":
                {
                    client.on("message", (message) => {
                        if (message.toString().startsWith(`{"channel"`)) {
                            cb(JSON.parse(JSON.parse(message.toString()).data));
                        }
                    });
                }
                break;
            case "open":
                {
                    client.on("open", () => {
                        cb(true);
                        return;
                    });
                }
                break;
        }
    }
    /**
     *
     * @param cb This will triggered when The client is ready.
     * @deprecated This will removed on first beta, please use `client.on("open")` instead.
     */
    onOpen(cb) {
        client.on("open", () => {
            cb(true);
            return;
        });
    }
    /**
     *
     * @param cb This will triggered when donation is detected
     * @deprecated This will removed on first beta, please use `client.on("donation")` instead.
     */
    onDonation(cb) {
        client.on("message", (message) => {
            if (message.toString().startsWith(`{"channel"`)) {
                cb(JSON.parse(JSON.parse(message.toString()).data));
            }
        });
    }
}
exports.Client = Client;
